(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@notabug/chaingun'), require('@notabug/gun-sear')) :
    typeof define === 'function' && define.amd ? define(['exports', '@notabug/chaingun', '@notabug/gun-sear'], factory) :
    (global = global || self, factory(global.notabugChaingunSear = {}, global.chaingun, global.gunSear));
}(this, function (exports, chaingun, gunSear) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */
    /* global Reflect, Promise */

    var extendStatics = function(d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };

    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    function __awaiter(thisArg, _arguments, P, generator) {
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
            function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
            function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }

    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f) throw new TypeError("Generator is already executing.");
            while (_) try {
                if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
                if (y = 0, t) op = [op[0] & 2, t.value];
                switch (op[0]) {
                    case 0: case 1: t = op; break;
                    case 4: _.label++; return { value: op[1], done: false };
                    case 5: _.label++; y = op[1]; op = [0]; continue;
                    case 7: op = _.ops.pop(); _.trys.pop(); continue;
                    default:
                        if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                        if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                        if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                        if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                        if (t[2]) _.ops.pop();
                        _.trys.pop(); continue;
                }
                op = body.call(thisArg, _);
            } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
            if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
        }
    }

    var ChainGunUserApi = /** @class */ (function () {
        function ChainGunUserApi(gun) {
            this._gun = gun;
        }
        /**
         *
         * https://gun.eco/docs/User#user-create
         *
         * @param alias
         * @param password
         * @param cb
         * @param opt
         */
        ChainGunUserApi.prototype.create = function (alias, password, cb, opt) {
            return __awaiter(this, void 0, void 0, function () {
                var user, ref, err_1;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            _a.trys.push([0, 2, , 3]);
                            return [4 /*yield*/, gunSear.createUser(this._gun, alias, password)];
                        case 1:
                            user = _a.sent();
                            ref = this.useCredentials(user);
                            if (cb)
                                cb(ref);
                            return [2 /*return*/, ref];
                        case 2:
                            err_1 = _a.sent();
                            if (cb)
                                cb({ err: err_1 });
                            throw err_1;
                        case 3: return [2 /*return*/];
                    }
                });
            });
        };
        /**
         *
         * https://gun.eco/docs/User#user-auth
         *
         * @param alias
         * @param password
         * @param cb
         * @param opt
         */
        ChainGunUserApi.prototype.auth = function (alias, password, cb, opt) {
            return __awaiter(this, void 0, void 0, function () {
                var user, ref, err_2;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            _a.trys.push([0, 2, , 3]);
                            return [4 /*yield*/, gunSear.authenticate(this._gun, alias, password)];
                        case 1:
                            user = _a.sent();
                            ref = this.useCredentials(user);
                            if (cb)
                                cb(ref);
                            return [2 /*return*/, ref];
                        case 2:
                            err_2 = _a.sent();
                            if (cb)
                                cb({ err: err_2 });
                            throw err_2;
                        case 3: return [2 /*return*/];
                    }
                });
            });
        };
        /**
         * https://gun.eco/docs/User#user-leave
         */
        ChainGunUserApi.prototype.leave = function () {
            if (this._signMiddleware) {
                this._gun.graph.unuse(this._signMiddleware, 'write');
                this._signMiddleware = undefined;
                this.is = undefined;
            }
        };
        ChainGunUserApi.prototype.useCredentials = function (credentials) {
            this.leave();
            this._signMiddleware = gunSear.graphSigner({
                pub: credentials.pub,
                priv: credentials.priv
            });
            this._gun.graph.use(this._signMiddleware, 'write');
            return (this.is = {
                alias: credentials.alias,
                pub: credentials.pub
            });
        };
        return ChainGunUserApi;
    }());

    var ChainGunSear = /** @class */ (function (_super) {
        __extends(ChainGunSear, _super);
        function ChainGunSear(graph, LinkClass) {
            if (LinkClass === void 0) { LinkClass = chaingun.ChainGunLink; }
            var _this = _super.call(this, graph, LinkClass) || this;
            _this.registerSearMiddleware();
            return _this;
        }
        ChainGunSear.prototype.registerSearMiddleware = function () {
            this.graph.use(gunSear.unpackGraph);
        };
        ChainGunSear.prototype.user = function () {
            return (this._user = this._user || new ChainGunUserApi(this));
        };
        return ChainGunSear;
    }(chaingun.ChainGun));

    Object.keys(chaingun).forEach(function (k) {
        if (k !== 'default') Object.defineProperty(exports, k, {
            enumerable: true,
            get: function () {
                return chaingun[k];
            }
        });
    });
    exports.ChainGunSear = ChainGunSear;
    exports.ChainGunUserApi = ChainGunUserApi;

    Object.defineProperty(exports, '__esModule', { value: true });

}));
//# sourceMappingURL=chaingun-sear.umd.js.map
